# sencillo exports

require! \Path
require! \Fs
# make this into a module!!
require \verse

export class Component extends Fsm
	(@config) ->

		super {
			states:
				uninitialized:
					_onEnter: ->
						try
							@component = require 'component'
							@builder = require 'component-builder'
						catch e
							throw new Error "TODO: I should fire up npm and make sure component is installed"

						if typeof config is \string then
							@config_path = config
							config = readFile config
						else
							@config_path = Path.join process.cwd!, "component.json"
						@config = Config @config_path, config, ~>
							@transition \building
						unless @config.build_dir then @config.build_dir = 'node_modules'
						@transition \ready

				ready:
					_onEnter: ->
						# check build dir and see if the files need to be built
						# @transition \building
						stat @config.build_dir, (st) ~>
							@build_dir_st = st
							if st.

				building:
					_onEnter: ->
						# do the building!!

			eventListeners:
		}

	log: (type, msg, color = '36') ->
		w = 10
		len = Math.max 0, w - type.length
		pad = Array len + 1 .join ' '
		console.log '  \033[' + color + 'm%s\033[m : \033[90m%s\033[m', pad + type, msg

	normalize: (deps) ->
		Object.keys deps .map (name) ->
			name + '@' + deps[name]

	add: (pkgs, cb) ->
		if typeof pkgs is \string
			pkgs = [pkgs]

		for pkg in pkgs
			parts = pkg.split('@')
			name = parts.shift!
			version = parts.shift! || 'master'
			rname = pkg.replace('/', '-')
			#TODO: if some time has passed, say 2-3 days, do an update instead of skipping it (for master)
			#TODO: when implementing specific versions, do a version compare here and update if necessary
			#if(Fs.existsSync(Path.join(odir, name))) return
			batch.push (done) ~> @install name, version, done

		batch.end -> cb!

	install: (pkg, cb) ->
		i = 0
		report = (pkg, options = {}) ->
			if pkg.inFlight then return

			@log 'install', pkg.name + '@' + pkg.version)
			pkg.on 'error', (err) ->
				if err.status isnt 404 then utils.fatal err.stack
				if options.error isnt false
					@log 'error', err.message)
					#process.exit(1)
					if pkg.name === name then cb err

			pkg.on 'dep', (dep) ->
				@log 'dep', dep.name + '@' + dep.version)
				report dep

			pkg.on 'exists', (dep) ->
				@log 'exists', dep.name + '@' + dep.version)
				if pkg.name === name then cb!

			pkg.on 'file', (file) ->
				@log 'fetch', pkg.name + ':' + file)

			pkg.on 'end', ! ->
				@log 'complete', pkg.name)
				if pkg.name === name then cb!

		pkg = @component.install name, version, {
			dest: "./build"
			dev: dev
			remotes: conf.remotes
		}

		report pkg
		pkg.install!






export class Npm extends Fsm
	(config) ->
		super {
			states:
				uninitialized:
					_onEnter: ->
						try
							@npm = require \npm
						catch e
							throw new Error "TODO: do a coool trick where I jump into node's main module dirs and require it from there :)"

						if typeof config is \string then
							@config_path = config
							config = readFile config
						else
							@config_path = Path.join process.cwd!, "package.json"
						@config = Config @config_path, config, ~>
							@transition \installing
						@transition \ready

				ready:
					_onEnter: ->
						# check modules dir and see if modules need to be installed
						# @transition \installing

				installing:
					_onEnter: ->
						# do the installing!!

			eventListeners:
		}


export class Repository extends Fsm
	(@path) ->
		@git = require Path.join __dirname, \build \Release \sencillo
		# TODO: look for an ini config parser


export class GitHub extends Fsm
	(@username) ->
		@github = new require('github') version: \3.0.0


